function [u]=descent(d, u, a, l, c, r, q)
% perform direct descent

num=max(size(d));	% number of data points

del_min=2^-5;		% minimum delta value
del=2;			% initial delta value

while(del>del_min)
  del=del/2;
  save_change=1;

  % loop until there are no more changes
  while(save_change==1)

    % initialize the arrays D and g (each value is an element of one of 
    % the two sums that are combined to make the function F)
    D=Dfun(d(1), u(1));
    for i=2:num
      D(i)=Dfun(d(i), u(i));
      g(i)=gfun(u(i), u(i-1), a, l, c, r, q);
    end

    % no changes
    save_change=0;

    % loop through each data point, testing if a change of del will result
    % in a lower overall value of F
    for i=1:num
      [changed, u(i), D(i), g(i), g1]=compare(D,g,i,del,u,d,a,l,c,r,q);
      if (changed==0)
        [changed, u(i), D(i), g(i), g1]=compare(D,g,i,-del,u,d,a,l,c,r,q);
      end
 
      if(changed==1)
	save_change=1;
	% avoid out of bounds error
	if(i~=num)
	  g(i+1)=g1;
	end % if(i)
      end % if (changed)
    end % for (i)

  end % while (save_change)
end % while (del)
